/* $Id: PSstruct.h,v 1.1.1.1 90/11/28 16:43:32 altenhof Exp $ */

/*
 * Copyright (C) 1990 by Digital Equipment Corporation.
 * 
 * Author: Michael P. Altenhofen, CEC Karlsruhe e-mail:
 * Altenhofen@kampus.enet.dec.com
 * 
 * This file ist part of Shared X
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation without fee is hereby granted, but only for non-profit  use
 * and distribution,  and provided  that the copyright notice and this notice
 * is preserved on all copies.
 * 
 * DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

#include "defs.h"
#include <X11/Xlib.h>

typedef struct _GCInfo {
  XID client_id;
  GC gc;
  struct _GCInfo *next;
} GCInfo;

typedef struct _Client {
  Display *xdpy;
  int index;
  pointer requestBuffer;
  pointer osPrivate;		/* for OS layer, including scheduler */
  Bool swapped;
  void (*pSwapReplyFunc) ();
  unsigned long errorValue;
  int sequence;
  unsigned long events;
  int closeDownMode;
  int clientGone;
  int noClientException;	/* this client died or needs to be killed */
  GCInfo *gc_list;
} ClientRec,

*ClientPtr;

#ifdef _USE_STRUCT_
#include <X11/Xlib.h>
#endif
