/* $Id: build.h,v 1.1.1.1 90/11/28 16:43:47 altenhof Exp $ */

/*
 * Copyright (C) 1990 by Digital Equipment Corporation.
 * 
 * Author: Michael P. Altenhofen, CEC Karlsruhe e-mail:
 * Altenhofen@kampus.enet.dec.com
 * 
 * This file ist part of Shared X
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation without fee is hereby granted, but only for non-profit  use
 * and distribution,  and provided  that the copyright notice and this notice
 * is preserved on all copies.
 * 
 * DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

#include <X11/Xlib.h>		/* to ensure consistency */
#include <X11/Xatom.h>

/* -- some definitions for BuildColor -- */
#define ColPixel   (1L<<0)
#define ColRed     (1L<<1)
#define ColGreen   (1L<<2)
#define ColBlue    (1L<<3)
#define ColFlags   (1L<<4)

/*
 * It would be nice if we could use constants in CheckProperty, but
 * DEC_WM_HINTS and DEC_WM_DECORATION_GEOMETRY are not predefined in
 * Xatom.h
 */

PUBLIC int
  Dec_Wm_Hints,
  Dec_Wm_Decoration_Geometry;

PUBLIC int
  PSComputeBytesPerLine (),
  PSComputeBitmapPadAndBitsPerPixel ();

PUBLIC void
  PSBuildProperty (),
  PSImageStripOffPadBytes (),
  PSBuildColors (),
  PSBuildWindowChanges (),
  PSBuildKeyboardControl (),
  PSBuildGCValues (),
  PSUpdateGCValues (),
  PSBuildSetWindowAttributes ();

PUBLIC XTextItem * PSBuildTextItems ();
PUBLIC XTextItem16 * PSBuildTextItems16 ();
