/* $Id: ps_table.c,v 1.1.1.1 90/11/28 16:45:34 altenhof Exp $ */

/*
 * Copyright (C) 1990 by Digital Equipment Corporation.
 * 
 * Author: Michael P. Altenhofen, CEC Karlsruhe e-mail:
 * Altenhofen@kampus.enet.dec.com
 * 
 * This file ist part of Shared X
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation without fee is hereby granted, but only for non-profit  use
 * and distribution,  and provided  that the copyright notice and this notice
 * is preserved on all copies.
 * 
 * DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

#define PUBLIC extern

#include <X11/X.h>

#include "requests.h"

#include "replies.h"

#include "events.h"

#undef PUBLIC

int (*Request_ProcVector[128]) () =
{
  _ProcBadRequest,
  _ProcCreateWindow,
  _ProcChangeWindowAttributes,
  _ProcGetWindowAttributes,
  _ProcDestroyWindow,
  _ProcDestroySubwindows,	/* 5 */
  _ProcChangeSaveSet,
  _ProcReparentWindow,
  _ProcMapWindow,
  _ProcMapSubwindows,
  _ProcUnmapWindow,		/* 10 */
  _ProcUnmapSubwindows,
  _ProcConfigureWindow,
  _ProcCirculateWindow,
  _ProcGetGeometry,
  _ProcQueryTree,		/* 15 */
  _ProcInternAtom,
  _ProcGetAtomName,
  _ProcChangeProperty,
  _ProcDeleteProperty,
  _ProcGetProperty,		/* 20 */
  _ProcListProperties,
  _ProcSetSelectionOwner,
  _ProcGetSelectionOwner,
  _ProcConvertSelection,
  _ProcSendEvent,		/* 25 */
  _ProcGrabPointer,
  _ProcUngrabPointer,
  _ProcGrabButton,
  _ProcUngrabButton,
  _ProcChangeActivePointerGrab,	/* 30 */
  _ProcGrabKeyboard,
  _ProcUngrabKeyboard,
  _ProcGrabKey,
  _ProcUngrabKey,
  _ProcAllowEvents,		/* 35 */
  _ProcGrabServer,
  _ProcUngrabServer,
  _ProcQueryPointer,
  _ProcGetMotionEvents,
  _ProcTranslateCoords,		/* 40 */
  _ProcWarpPointer,
  _ProcSetInputFocus,
  _ProcGetInputFocus,
  _ProcQueryKeymap,
  _ProcOpenFont,		/* 45 */
  _ProcCloseFont,
  _ProcQueryFont,
  _ProcQueryTextExtents,
  _ProcListFonts,
  _ProcListFontsWithInfo,	/* 50 */
  _ProcSetFontPath,
  _ProcGetFontPath,
  _ProcCreatePixmap,
  _ProcFreePixmap,
  _ProcCreateGC,		/* 55 */
  _ProcChangeGC,
  _ProcCopyGC,
  _ProcSetDashes,
  _ProcSetClipRectangles,
  _ProcFreeGC,			/* 60 */
  _ProcClearToBackground,
  _ProcCopyArea,
  _ProcCopyPlane,
  _ProcPolyPoint,
  _ProcPolyLine,		/* 65 */
  _ProcPolySegment,
  _ProcPolyRectangle,
  _ProcPolyArc,
  _ProcFillPoly,
  _ProcPolyFillRectangle,	/* 70 */
  _ProcPolyFillArc,
  _ProcPutImage,
  _ProcGetImage,
  _ProcPolyText,
  _ProcPolyText,		/* 75 */
  _ProcImageText,
  _ProcImageText,
  _ProcCreateColormap,
  _ProcFreeColormap,
  _ProcCopyColormapAndFree,	/* 80 */
  _ProcInstallColormap,
  _ProcUninstallColormap,
  _ProcListInstalledColormaps,
  _ProcAllocColor,
  _ProcAllocNamedColor,		/* 85 */
  _ProcAllocColorCells,
  _ProcAllocColorPlanes,
  _ProcFreeColors,
  _ProcStoreColors,
  _ProcStoreNamedColor,		/* 90 */
  _ProcQueryColors,
  _ProcLookupColor,
  _ProcCreateCursor,
  _ProcCreateGlyphCursor,
  _ProcFreeCursor,		/* 95 */
  _ProcRecolorCursor,
  _ProcQueryBestSize,
  _ProcQueryExtension,
  _ProcListExtensions,
  _ProcChangeKeyboardMapping,	/* 100 */
  _ProcGetKeyboardMapping,
  _ProcChangeKeyboardControl,
  _ProcGetKeyboardControl,
  _ProcBell,
  _ProcChangePointerControl,	/* 105 */
  _ProcGetPointerControl,
  _ProcSetScreenSaver,
  _ProcGetScreenSaver,
  _ProcChangeHosts,
  _ProcListHosts,		/* 110 */
  _ProcChangeAccessControl,
  _ProcChangeCloseDownMode,
  _ProcKillClient,
  _ProcRotateProperties,
  _ProcForceScreenSaver,	/* 115 */
  _ProcSetPointerMapping,
  _ProcGetPointerMapping,
  _ProcSetModifierMapping,
  _ProcGetModifierMapping,
  0,				/* 120 */
  0,
  0,
  0,
  0,
  0,				/* 125 */
  0,
  _ProcNoOperation
};


int (*Event_ProcVector[35]) () =
{
  NotImplementedEvent,		/* 0 */
  NotImplementedEvent,
  _ProcKeyEvent,
  _ProcKeyEvent,
  _ProcButtonEvent,
  _ProcButtonEvent,		/* 5 */
  _ProcMotionNotifyEvent,
  _ProcEnterLeaveEvent,
  _ProcEnterLeaveEvent,
  _ProcFocusEvent,
  _ProcFocusEvent,		/* 10 */
  _ProcKeymapNotifyEvent,
  _ProcExposeEvent,
  _ProcGraphicsExposeEvent,
  _ProcNoExposeEvent,
  _ProcVisibilityNotifyEvent,	/* 15 */
  _ProcCreateNotifyEvent,
  _ProcDestroyNotifyEvent,
  _ProcUnmapNotifyEvent,
  _ProcMapNotifyEvent,
  _ProcMapRequestEvent,		/* 20 */
  _ProcReparentNotifyEvent,
  _ProcConfigureNotifyEvent,
  _ProcConfigureRequestEvent,
  _ProcGravityNotifyEvent,
  _ProcResizeRequestEvent,	/* 25 */
  _ProcCirculateNotifyEvent,
  _ProcCirculateRequestEvent,
  _ProcPropertyNotifyEvent,
  _ProcSelectionClearEvent,
  _ProcSelectionRequestEvent,	/* 30 */
  _ProcSelectionNotifyEvent,
  _ProcColormapNotifyEvent,
  _ProcClientMessageEvent,
  _ProcMappingNotifyEvent,
};
